#include "ELF64.h"

#include <ehs/EHS.h>
#include <ehs/io/Console.h>
#include <ehs/io/File.h>

ehs::SInt_32 Main(ehs::Str_8* appName, ehs::Str_8* appVerId, ehs::Version* appVer)
{
	*appName = "Compiler";
	*appVerId = "Alpha";
	*appVer = {1, 0, 0};

	ehs::Vector<ehs::Str_8> args = ehs::Console::GetArgs_8();
	if (args.Size() <= 1)
	{
		ehs::Console::Write_8(*appName + " " + *appVerId + " v" + ehs::Str_8::FromNum(appVer->major) + "." +
			ehs::Str_8::FromNum(appVer->minor) + "." + ehs::Str_8::FromNum(appVer->patch));

		return 0;
	}

	ehs::File codeFile(args[1].RemoveAll("\""), ehs::Mode::READ, ehs::Disposition::OPEN);
	ehs::Serializer<ehs::UInt_64> code = codeFile.ReadSerializer_64(ehs::Endianness::LE, codeFile.Size());
	codeFile.Release();

	ELF64 executable(ELFH_ARCH_64, ELFH_END_LE, ELFH_ABI_SYSTEMV, ELFH_TYPE_EXEC, ELFH_MARCH_AMD_X86_64);

	ELF64_Section text(".text", SECH_TYPE_PROGBITS, SECH_FLAG_ALLOC | SECH_FLAG_EXEC, 16);
	text.SetData(code);
	executable.AddSection(text);

	executable.AddProgram({2, PRGH_TYPE_LOAD, PRGH_FLAG_EXEC | PRGH_FLAG_READ, 0x400000, 0x200000});

	ehs::File file(args[2].RemoveAll("\""), ehs::Mode::WRITE, ehs::Disposition::CREATE_PERSISTENT);
	file.WriteSerializer_64(executable.Serialize());

	return 0;
}
